<!--
  The iframe script to communicate with the content-deprecated.js.
  Reference: https://github.com/muaz-khan/WebRTC-Experiment/tree/master/DetectRTC
  Author: Muaz Khan
  License: MIT license
 -->
<html>
<head>
<meta name="author" content="Temasys">
<meta name="version" content="0.1.3">
<meta name="date" content="Fri Aug 25 2017 12:52:53 GMT+0800 (+08)">
<script>
// Configuration settings
var iframe = {
  states: {
    active: false,
    timer: null,
    timerTerminated: false
  },
  config: {
    // Set your preferred default extension ID
    defaultExtensionId: 'ljckddiekopnnjoeaiofddfhgnbdoafc',
    // Set your preferred default extension link
    defaultExtensionInstallLink: 'https://chrome.google.com/webstore/detail/skylink-webrtc-tools/ljckddiekopnnjoeaiofddfhgnbdoafc',
    // Set your preferred timeout here by manipulating the [2500] value
    responseTimeout: 2500
  }
};
var cachedSources = [];
var cachedLegacy = false;

// Listen to messages from content-deprecated.js and adapter.screenshare.js
window.addEventListener('message', function (evt) {
  // Check if chrome extension is active and then get source ID
  if (evt.data && typeof evt.data === 'object' && evt.data.captureSourceId) {
    var extensionId = iframe.config.defaultExtensionId;
    var extensionInstallLink = iframe.config.defaultExtensionInstallLink;

    // User has provided a custom extension ID
    if (evt.data.extensionId) {
      extensionId = evt.data.extensionId;
      if (evt.data.extensionLink) {
        extensionInstallLink = evt.data.extensionLink;
      }
    }

    // For fallback of legacy extensions that has no way of specifying sources
    cachedLegacy = evt.data.legacy !== false;
    cachedSources = evt.data.sources;

    var icon = document.createElement('img');
    iframe.states.timerTerminated = false;

    icon.src = 'chrome-extension://' + extensionId + '/icon.png';
    icon.onload = function() {
      iframe.states.active = false;
      // Check if extension exists
      window.postMessage('are-you-there', '*');
      // Check if extension has overriden global variable, which means its active
      iframe.states.timer = setTimeout(function () {
        // Ignore as it is meant to be terminated
        if (iframe.states.timerTerminated) {
          return;
        }

        iframe.states.timerTerminated = true;

        // Ignore because it's not active
        if (!iframe.states.active) {
          window.parent.postMessage({
            chromeExtensionStatus: 'installed-disabled',
            data: extensionInstallLink,
            installLink: extensionInstallLink
          }, '*');
          return;
        }

      }, iframe.config.responseTimeout);
    };
    icon.onerror = function () {
      window.parent.postMessage({
        chromeExtensionStatus: 'not-installed',
        data: extensionInstallLink,
        installLink: extensionInstallLink
      }, '*');
    };

  // content-deprecated.js just responded that it is active
  } else if (evt.data === 'rtcmulticonnection-extension-loaded') {
    iframe.states.timerTerminated = true;
    iframe.states.active = true;
    if (iframe.states.timer) {
      clearTimeout(iframe.states.timer);
    }
    // Request to get source ID
    if (cachedLegacy) {
      window.postMessage('get-sourceId', '*');
    } else {
      window.postMessage({
        type: 'get-sourceId',
        sources: cachedSources
      }, '*');
    }
    return;

  // Forward background-deprecated.js response
  } else if (evt.data === 'PermissionDeniedError' || (evt.data && typeof evt.data === 'object' && evt.data.sourceId)) {
    window.parent.postMessage({
      chromeMediaSourceId: typeof evt.data === 'string' ? evt.data : evt.data.sourceId
    }, '*');
    return;
  }
});
</script>
</head>
<body></body>
</html>
